import { NS } from '@ns'
import { selectAllContract, isSolvable, solveContract } from './lib/contract'

export async function main(ns : NS) : Promise<void> {
    const remoteList = selectAllContract(ns);
    for (const contract of remoteList) {
        if(isSolvable(ns,contract.filename,contract.hostname)){
            const [success, reward] = await solveContract(ns,contract.filename,contract.hostname);
            if(success){
                ns.tprint(`solve ${contract.filename}`);
                ns.tprint(reward);
            }
            else{
                ns.tprint("stop")
                break;
            }
        }
    }
}