/* eslint-disable @typescript-eslint/explicit-function-return-type */


enum Direction{
    RIGHT = 0,
    DOWN = 1,
    LEFT = 2,
    UP = 3
}

export function spiral(arr: number[][]):number[] {
    const w = arr[0].length;
    const h = arr.length;

    let x = -1, y = 0;
    let wdepth = w;
    let hdepth = h - 1;
    let dir:Direction = Direction.RIGHT;
    const ret: number[] = [];
    //ret.push(arr[y][x]);
    for (;;) {
        if(wdepth == 0) break;
        //console.log(wdepth);
        stepN(wdepth);
        dir = turn90(dir);
        if(hdepth == 0) break;
        //console.log(hdepth);
        stepN(hdepth);
        dir = turn90(dir);
        wdepth--;
        hdepth--;
    }
    return ret;
    function turn90(d: Direction){
        return (d + 1)% 4;
    }
    function stepN(n:number){
        for (let i = 0; i < n; i++) {
            step();
        }
    }
    function step(){
        switch(dir){
            case Direction.RIGHT:
                x++;
            break;
            case Direction.DOWN:
                y++;
            break;
            case Direction.LEFT:
                x--;
            break;
            case Direction.UP:
                y--;
            break;
        }
        ret.push(arr[y][x]);
    }
}

export function spiralSolve(arr:number[][]):string[]{
    return spiral(arr).map(x=>x.toString());
}

const case1: [number[][],number[]] = [[[1,2,3],
[4,5,6],
[7,8,9]],
[1, 2, 3, 6, 9, 8, 7, 4, 5]
];

const case2: [number[][],number[]] =[
    [[1,  2,  3,  4],
    [5,  6,  7,  8],
    [9, 10, 11, 12],],
    [1,  2,  3, 4, 8,12, 11, 10, 9, 5,6,  7]
];

const case3: [number[][],number[]] = [[
    [33,11,20,23,11,47,31,16,41,49],
    [37,32,14,34,30,18,15,17,45,36],
    [ 9,22,40,35,19,12,23,16,37, 5],
],
[33, 11, 20, 23, 11, 47, 31, 16, 41,49, 36,  5, 37, 16, 23, 12, 19, 35,40, 22,  9, 37, 32, 14, 34, 30, 18,15, 17, 45]
]

export const testcases: Array<[number[][],number[]]> = [
    case1,
    case2,
    case3
];